var scanloglist = [];
var summary_page = 1;
var summary_ofpage = 50;
var summary_pagecount = 1;

function createDeleteCLamavLogW(lognos) {
  var cwh = getClientWH();
  var CreateDeleteCLamavLogW = new MUI.Modal({
    id: 'CreateDeleteCLamavLogWindow',
    title: UNAS._('Delete Log File'),
    modal: true,
    width: parseInt(cwh.w * 0.88),
    height: 200, //+50
    addClass:'delete-modal',
    data: {
      lognos: lognos
    },
    modalOverlayClose: false,
    contentURL: '/apps/antivirus/m/clamav_log_delete.html?v=6.0.11'
  });
  CreateDeleteCLamavLogW.ProcessDeleteCLamavLogWindow = function() {
    scanloglist = [];
    summary_page = 1;
    jQuery('#clamav_logfile_list').empty();
    getClamavScanLogList(summary_page, summary_ofpage);
  }
}

jQuery('#clamav_log_search').keyup(function() {
  jQuery('#clamav_logfile_list tr').hide().filter(":contains('" + (jQuery(this).val()) + "')").show();
}).keyup();

function seeClamavLog(file) {

  var seeLamavLogWin = new MUI.Modal({
    id: 'seeLamavLogWindow',
    title: UNAS._('##$@clamav@$##Log Info##$@clamav@$##'),
    modal: true,
    width: 750,
    height: 320,
    modalOverlayClose: false,
    contentURL: '/apps/antivirus/clamavlog.html?v=6.0.11&file=' + file
  });

}

function getClamavScanLogList(page, ofpage, s = true) {
  if (s) {
    jQuery('#clamav_index_page_waiting_content').show();
    jQuery('#clamav_index_page_waiting_logo').show();
  }
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_log_alload',
      params: {
        page: page,
        ofpage: ofpage
      }
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var scanloglist = info.records || [];
      summary_pagecount = Math.ceil(info.reccount / summary_ofpage) || 1;
      summary_page = info.page;

      for (var j = 0; j < scanloglist.length; j++) {
        var t_ = scanloglist[j];
        var logdom = clamTemplateAppend('#clamav_logfile_list', 'jvt-scanlogitem', 'jvt-scanlogitem-' + summary_page + j)
        logdom.find('.jvc-ff').text(t_.file || "--");
        logdom.find('.jvc-filepath').text(t_.path).attr('title', t_.path);
        logdom.find('.jvc-filetotal').text(t_.totality || '--');
        logdom.find('.jvc-infectes').text(t_.infectes || 0);
        if (t_.infectes) {
          logdom.find('.jvc-infectes').addClass('infected-y');
        } else {
          logdom.find('.jvc-infectes').addClass('infected-n');
        }

        logdom.find('.jvc-endtime').text(t_.endtime || '--');
        logdom.find('.jvc-starttime').text(t_.starttime || '--');
        if (t_.type == 'file') {
          logdom.find('.jvc-ff').addClass('filetypeicon');
        } else {
          logdom.find('.jvc-ff').addClass('foldertypeicon');
        }

        logdom.find('.jvc-scanlogchk').val(t_.logno).on('click', function() {
          setDeletebuttonstate();
        });

        logdom.find('.clamav_icon_delete').data('loginfo', t_).on('click', function() {
          var loginfo = jQuery(this).data('loginfo');
          createDeleteCLamavLogW([loginfo.logno]);
        })

        // logdom.find('.clamav_icon_see').data('loginfo', t_).on('click', function() {
        // 	var loginfo = jQuery(this).data('loginfo');
        // 	seeClamavLog(loginfo.path);
        // })

      }

      var allscanlog = jQuery('#clamav_logfile_list input[name="scanlog"]');
      if (jQuery('#jv-allscanlogck').prop("checked")) {
        allscanlog.prop('checked', true);
      }

      setDeletebuttonstate();

    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function setDeletebuttonstate() {
  var allscanlog = jQuery('#clamav_logfile_list input[name="scanlog"]');
  var len = allscanlog.length;

  var cklen = jQuery('#clamav_logfile_list input[name="scanlog"]:checked').length;

  if (cklen) {
    jQuery('#jv-deleteallscanlog').attr('class', 'unas_button_content');
  } else {
    jQuery('#jv-deleteallscanlog').attr('class', 'unas_button_content_disabled');
  }
}

function downloadLogFile(url, type) {
  // $('#jv-docker_loading').show();
  var request = new XMLHttpRequest();
  request.responseType = "blob";
  let fileUrl = url; // 文件路径
  request.open("GET", fileUrl);
  request.onload = function() {
    var url = window.URL.createObjectURL(this.response);
    var $a = document.createElement('a');
    $a.setAttribute("href", url);
    $a.setAttribute("download", type);
    var evObj = document.createEvent('MouseEvents');
    evObj.initMouseEvent('click', true, true,
      window, 0, 0, 0, 0, 0, false, false, true, false, 0, null);
    $a.dispatchEvent(evObj);
    // $('#jv-docker_loading').hide();
  }
  request.send();
}

(function() {

  jQuery('#jv-allscanlogck').on('click', function() {
    var allscanlog = jQuery('#clamav_logfile_list input[name="scanlog"]');
    if (this.checked) {
      allscanlog.prop('checked', true);
    } else {
      allscanlog.prop('checked', false);
    }
    setDeletebuttonstate();
  })

  jQuery('#jv-deleteallscanlog').on('click', function() {
    var allscanlog = jQuery('#clamav_logfile_list input[name="scanlog"]:checked');
    var lognos = [];
    for (var i = 0; i < allscanlog.length; i++) {
      lognos.push(jQuery(allscanlog[i]).val());
    }
    createDeleteCLamavLogW(lognos);
  })

  // jQuery("#clamav_logfile_content").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark",
  //   callbacks: {
  //     onScrollStart: function() {},
  //     onScroll: function() {},
  //     onTotalScroll: function() {
  //
  //       if (summary_page == summary_pagecount) {
  //
  //       } else {
  //         summary_page++;
  //         getClamavScanLogList(summary_page, summary_ofpage);
  //       }
  //
  //     }
  //   }
  // });

  jQuery('#clamav_logfile_content').scroll(function() {
    // 获取div的总高度
    var totalHeight = jQuery(this)[0].scrollHeight;
    // 获取可视区域的高度
    var viewportHeight = jQuery(this).height();
    // 获取当前滚动条的位置
    var scrollTop = jQuery(this).scrollTop();
    // 检查是否已经到达底部
    var isBottom = totalHeight - (scrollTop + viewportHeight) <= 0;

    if (isBottom) {
      summary_page++;
      getClamavScanLogList(summary_page, summary_ofpage, false);
    }
  });

  getClamavScanLogList(summary_page, summary_ofpage);

  if (daemonstate) {
    jQuery('#clamav_log_search').removeClass('disabledbtn');
    jQuery('#clamav_logfile_list').removeClass('disabledbtn');
  } else {
    jQuery('#clamav_log_search').addClass('disabledbtn');
    jQuery('#clamav_logfile_list').addClass('disabledbtn');
  }

})();
