var settingpretime = 0;
var freshclamtime = null;
var isolation = '';
var weekArray = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
(function() {
  jQuery(".clamav_file_list_content").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark",
    axis: "yx",
    autoDraggerLength: true,
    scrollButtons: true
  });
  jQuery(".clamav_file_list_content").mCustomScrollbar("update");
})();

//手动更新
function clamavHandleUpdate() {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();
  clearTimeout(freshclamtime);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_updvdb_start'
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    timeout: 30000,
    success: function(res) {

      if (res.err == 0) {
        jQuery(".clamav_start_update").css("display", "none");
        jQuery(".clamav_stop_update").css("display", "block");
        jQuery("#jv-chubtn").hide();
        jQuery("#jv-updatetime").hide();
        getPassiveFreshClamavStatus();

      } else {
        alert('Operation failed!');
      }
    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}
//获取隔离区目录以及其他状态
function getClamavIsolationDir() {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();
  jQuery.ajax({
    url: "/wmi/index.php",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_settings_load'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        var info = res.results || {};
        var schedule = info.schedule || {};
        daemonstate = info.enabled;

        jQuery("#start_clamdaemon").prop('checked', info.enabled).attr('oldv', info.enabled);

        // jQuery("#jv-onaccess").prop('checked');
        jQuery("#jv-mst").val(info.threads || 1);

        jQuery("#auto_start_freshclamav").prop('checked', info.auto);
        jQuery("#start_freshdaemon").prop('checked', info.vdbauto);
        jQuery("#clamav_isolation_file").val(info.datadir);
        isolation = info.datadir;
        setOpStatus(info.enabled);

        if (info.enabled) {
          getPassiveFreshClamavStatus();
          if (info.datadir) {
            jQuery('#jv-chubtn').attr('class', 'unas_button_content');
            jQuery('#jv-clamavsetbtn').attr('class', 'unas_button');
          } else {
            jQuery('#jv-chubtn').attr('class', 'unas_button_content_disabled');
            jQuery('#jv-clamavsetbtn').attr('class', 'unas_button_disabled');
          }

        } else {
          clearTimeout(freshclamtime);
          jQuery('#jv-clamavsetbtn').attr('class', 'unas_button_disabled');
          jQuery('#jv-chubtn').attr('class', 'unas_button_content_disabled');
        }

        if (schedule && schedule.mode) {
          jQuery("#jv-autoscan").prop('checked', 1);
          jQuery('#jv-autoscansetup').show();

          jQuery('#create_clamscan_hours').val(schedule.hour || 0);
          jQuery('#create_clamscan_minutes').val(schedule.minute || 0);

          if (schedule.mode == 1) {
            jQuery("#create_clamscan_daily").attr("checked", true);
            jQuery('#create_clamscan_days_cont').hide();
            jQuery('#create_clamscan_weeks_cont').hide();
          } else if (schedule.mode == 2) {
            jQuery("#create_clamscan_weekly").attr("checked", true);
            jQuery('#create_clamscan_weeks').val(schedule.week);
            jQuery('#create_clamscan_days_cont').hide();
            jQuery('#create_clamscan_weeks_cont').show();
          } else {
            jQuery('#create_clamscan_days_cont').show();
            jQuery('#create_clamscan_weeks_cont').hide();
            jQuery("#create_clamscan_monthly").attr("checked", true);
            jQuery('#create_clamscan_days').val(schedule.day || 1);
          }

          if (schedule.scope == 1) {
            jQuery('input:radio[value="all"]').prop('checked', 1);
          } else {
            jQuery('input:radio[value="part"]').prop('checked', 1);
          }

        } else {
          jQuery("#jv-autoscan").prop('checked', 0);
          jQuery('#jv-autoscansetup').hide();
        }

      }

    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function setOpStatus(daemon) {

  if (daemon) {
    jQuery("#start_freshdaemon").attr('disabled', false);
    jQuery("#jv-onaccess").attr('disabled', false);
    jQuery("#jv-mst").attr('disabled', false);
    jQuery('.clamav_start_update').removeClass('disabledbtn');
    jQuery("#clamav_isolation_file").attr('disabled', false);
    jQuery('.clamav_select_img').removeClass('disabledbtn');
    jQuery("#jv-autoscan").attr('disabled', false);
    jQuery('#jv-autoscansetup input').attr('disabled', false);
    jQuery('#jv-autoscansetup select').attr('disabled', false);

  } else {
    jQuery("#start_freshdaemon").attr('disabled', true);
    jQuery("#jv-onaccess").attr('disabled', true);
    jQuery("#jv-mst").attr('disabled', true);

    jQuery('.clamav_start_update').addClass('disabledbtn');
    jQuery("#clamav_isolation_file").attr('disabled', true);
    jQuery('.clamav_select_img').addClass('disabledbtn');
    jQuery("#jv-autoscan").attr('disabled', true);

    jQuery('#jv-autoscansetup input').attr('disabled', true);
    jQuery('#jv-autoscansetup select').attr('disabled', true);


  }
}

//获取更新状态
function getPassiveFreshClamavStatus() {
  clearTimeout(freshclamtime);
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_updvdb_running'
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      if (res.err == 0) {

        jQuery(".clamav_start_update").css("display", "none");
        jQuery(".clamav_stop_update").css("display", "block");
        jQuery("#jv-chubtn").hide();
        jQuery("#jv-updatetime").hide();
        var rate = info.rate || 0;
        if (rate > 100) {
          rate = 100;
        }
        var position = getByteString(info.position || 0);
        var total = getByteString(info.total || 0);
        if (info.total) {
          jQuery('#jv-scanprotxt').text(position + '/' + total);
        } else {
          jQuery('#jv-scanprotxt').text(UNAS._("Checking for upgradable versions..."));
        }

        jQuery('#jv-scanprobar').css('width', rate + '%');

        if (info.success) {

        } else {
          if (rate == 100) {
            jQuery('#jv-clamavupdated').hide();
            jQuery('#jv-meter').hide();
          } else {
            jQuery('#jv-clamavupdated').show();
            jQuery('#jv-meter').show();
          }
        }

      } else {

        jQuery('#jv-scanprotxt').text('0B/0B');
        jQuery('#jv-scanprobar').css('width', '0%');
        jQuery(".clamav_start_update").css("display", "block");
        jQuery(".clamav_stop_update").css("display", "none");
        jQuery("#jv-chubtn").show();
        jQuery("#jv-updatetime").show();
        if (info.updatetime) {
          jQuery("#jv-updatetime").text(info.updatetime + UNAS._("Update"));
        } else {
          jQuery("#jv-updatetime").text(UNAS._("Please check for updates"));
        }

      }

    },
    complete: function(xml) {
      if (jQuery(".clamav_setting_page").length) {
        freshclamtime = setTimeout(function() {
          getPassiveFreshClamavStatus();
        }, 2000);
      } else {
        clearTimeout(freshclamtime);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })

}
//停止更新
function stopFreshClamav() {
  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_updvdb_stop'
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    timeout: 30000,
    success: function(result) {

    }
  })
}

//设置
function clamavSetting() {

  var daemon = jQuery("#start_clamdaemon").prop('checked') ? 1 : 0;
  var onaccess = jQuery("#jv-onaccess").prop('checked') ? 1 : 0;
  var threads = +jQuery("#jv-mst").val() || 1;
  var fresh = jQuery("#start_freshdaemon").prop('checked') ? 1 : 0;
  var autoscan = jQuery("#jv-autoscan").prop('checked') ? 1 : 0;
  var isolation = jQuery("#clamav_isolation_file").val();
  var timetype = jQuery("input:radio[name='create_clamscan_schedule_type']:checked").val();
  var tasktype = jQuery("input:radio[name='select_file']:checked").val();
  var hour = +jQuery("#create_clamscan_hours").val();
  var minute = +jQuery("#create_clamscan_minutes").val();
  var day = +jQuery("#create_clamscan_days").val();
  var week = +jQuery("#create_clamscan_weeks").val();
  var interval = 0;
  var scope = 1;
  var intervaltype = {
    day: 1,
    week: 2,
    month: 3
  }
  if (autoscan) {
    interval = intervaltype[timetype];
  }
  if (tasktype != 'all') {
    scope = 2;
  }

  var schedule = {
    mode: interval,
    hour: hour,
    minute: minute,
    scope: scope,
    day: day,
    week: week
  };

  if (threads >= 100) {
    alert(UNAS._('The concurrent quantity is too large.'));
    return;
  }

  if (!isolation && daemon) {
    alert(UNAS._('Please select an isolation'));
    return;
  }

  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();
  jQuery.ajax({
    url: "/wmi/index.php",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_settings_save',
      "params": {
        datadir: isolation,
        enabled: daemon,
        vdbauto: fresh,
        threads: threads,
        schedule: schedule
      }
    }),
    contentType: 'application/json',
    dataType: "json",
    type: "post",
    timeout: 30000,
    success: function(res) {

      if (res.err == 0) {
        getClamavIsolationDir();
      } else {
        if (antivirus_errcode[res.err]) {
          alert(UNAS._(antivirus_errcode[res.err]));
        } else {
          alert(UNAS._('Operation failed!'));
        }
      }
      jQuery('.clamav_file_list').css("display", "none");
    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}
jQuery(".clamav_file_list_top").click(function() {
  jQuery("#clamav_iso_filetree").text("");
  jQuery(".clamav_file_list").css("display", "none");
})
//getISOPathTree();
jQuery(".clamav_select_img").click(function() {
  getClamavISOPathTree('#clamav_isolation_file');
  jQuery(".clamav_file_list").css("display", "block");
})
jQuery("#clamav_isolation_file").click(function() {
  getClamavISOPathTree('#clamav_isolation_file');
  jQuery(".clamav_file_list").css("display", "block");
})

function displayTime() {
  var sel_hour = jQuery('#create_clamscan_hours');
  var sel_minutes = jQuery('#create_clamscan_minutes');
  var sel_weeks = jQuery('#create_clamscan_weeks');
  var sel_days = jQuery('#create_clamscan_days');

  for (var i = 0; i < 24; i++) {
    sel_hour.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 0; i < 60; i++) {
    sel_minutes.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 1; i < 7; i++) {
    sel_weeks.append('<option value="' + i + '">' + UNAS._(weekArray[i]) + '</option>');
  }

  sel_weeks.append('<option value="0">' + UNAS._(weekArray[0]) + '</option>');

  for (var i = 1; i <= 31; i++) {
    sel_days.append('<option value="' + i + '">' + i + '</option>');
  }
}

function clamavTaskTimeStatus() {
  var selected_time_type = jQuery("input:radio[name='create_clamscan_schedule_type']:checked").val();
  if (selected_time_type == "day") {
    jQuery("#create_clamscan_weeks").attr("disabled", true);
    jQuery("#create_clamscan_days").attr("disabled", true);

    jQuery("#create_clamscan_weeks_cont").css("display", "none");
    jQuery("#create_clamscan_days_cont").css("display", "none");
  }
  if (selected_time_type == "week") {
    jQuery("#create_clamscan_weeks").attr("disabled", false);
    jQuery("#create_clamscan_days").attr("disabled", true);

    jQuery("#create_clamscan_weeks_cont").css("display", "block");
    jQuery("#create_clamscan_days_cont").css("display", "none");
  }
  if (selected_time_type == "month") {
    jQuery("#create_clamscan_weeks").attr("disabled", true);
    jQuery("#create_clamscan_days").attr("disabled", false);

    jQuery("#create_clamscan_weeks_cont").css("display", "none");
    jQuery("#create_clamscan_days_cont").css("display", "block");
  }
}

jQuery("input:radio[name='create_clamscan_schedule_type']").click(function() {
  clamavTaskTimeStatus();
});

(function() {
  displayTime();
  clamavTaskTimeStatus();

  jQuery('#jv-autoscan').click(function() {
    if (this.checked) {
      jQuery('#jv-autoscansetup').show();
    } else {
      jQuery('#jv-autoscansetup').hide();
    }

  })

  jQuery('#start_clamdaemon').click(function() {
    setOpStatus(this.checked);
    var file = jQuery('#clamav_isolation_file').val();
    var oldv = +jQuery(this).attr('oldv');
    var nv = this.checked ? 1 : 0;
    if (this.checked) {
      if (file) {
        jQuery('#jv-clamavsetbtn').attr('class', 'unas_button');
      } else {
        jQuery('#jv-clamavsetbtn').attr('class', 'unas_button_disabled');
      }
    } else {
      if (oldv == nv) {
        jQuery('#jv-clamavsetbtn').attr('class', 'unas_button_disabled');
      } else {
        jQuery('#jv-clamavsetbtn').attr('class', 'unas_button');
      }
    }

  })

  getClamavIsolationDir();


  jQuery('#jv-mst').bind('input propertychange', function(e) {

    if (+jQuery(this).val() < 1) {
      jQuery(this).attr("class", "unas_input_error");
    } else {
      jQuery(this).attr("class", "unas_input");
    }

  });

})();
