var quarantined_page = 1;
var quarantined_ofpage = 50
var quarantined_pagecount = 1;

function clamavIsolationFileList(page, ofpage) {

  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'antivirus_quarantined_alload',
      params: {
        page: page,
        ofpage: ofpage
      }
    }),
    dataType: "json",
    contentType: 'application/json',
    type: "post",
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var files = info.records || [];
      quarantined_pagecount = Math.ceil(info.reccount / quarantined_ofpage) || 1;
      quarantined_page = info.page;

      for (var i = 0; i < files.length; i++) {
        var t_ = files[i];
        var isolationfiledom = clamTemplateAppend('#clamav_isolationfile_list', 'jvt-isolationfilestr', 'jvt-isolationfilestr-' + quarantined_page + i);
        isolationfiledom.find('.jvc-isolationfilename').text(t_.filename || '--').attr('title', t_.filename);
        isolationfiledom.find('.filepathtitle').text('##$@clamav@$##File path##$@clamav@$##');
        isolationfiledom.find('.virustitle').text('##$@clamav@$##Virus##$@clamav@$##');
        if (t_.removed) {
          isolationfiledom.find('.jvc-isolationfilename').addClass('deactivatedicon');
        } else {
          isolationfiledom.find('.jvc-isolationfilename').removeClass('deactivatedicon');
        }
        if (t_.virus) {
          isolationfiledom.find('.jvc-virus').text(t_.virus).attr('title', t_.virus);
        } else {
          isolationfiledom.find('.jvc-virus').text('##$@clamav@$##Unknown Virus##$@clamav@$##');
        }


        isolationfiledom.find('.jvc-isolationfilepath').text(t_.path || '--').attr('title', t_.path);

        isolationfiledom.find('.jvc-isolationfilechk').val(t_.iftno).on('click', function() {
          var allisolationfile = jQuery('#clamav_isolationfile_list input[name="isolationfiles"]');
          var len = allisolationfile.length;
          var cklen = jQuery('#clamav_isolationfile_list input[name="isolationfiles"]:checked').length;

        });

        isolationfiledom.find('.clamav_icon_renew').data('info', t_).on('click', function() {
          var that_info = jQuery(this).data('info');
          recoverySelectedFiles(that_info.iftno)
        })

        isolationfiledom.find('.clamav_icon_delete').data('info', t_).on('click', function() {
          var that_info = jQuery(this).data('info');
          removesolation(that_info.iftno);
        })

      }

      (function() {
        var rt_p = document.getElementById('clamav_isolationfile_list');
        var pageTranslators_log = window.top.UNAS.CreateNodesTranslators(rt_p.parentNode);
        var OnChangeLanguage_log = function(e) {
          for (var i = 0; i < pageTranslators_log.length; i++) {
            var node = pageTranslators_log[i].node;
            var p = pageTranslators_log[i].translateProperty;
            node[p] = window.top.UNAS._(pageTranslators_log[i].originalText);
          }
        };
        OnChangeLanguage_log();
        window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage_log);
        window.addEventListener("unload", function(e) {
          window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage_log);
          window.top.UNAS.SetAppState("Clam Av", "inactive");
        }, false);
      })()


      var allisolationfile = jQuery('#clamav_isolationfile_list input[name="isolationfiles"]');
      if (jQuery('#jv-isolationallchk').prop("checked")) {
        allisolationfile.prop('checked', true);
      }

    },
    complete: function() {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    }
  })
}

//文件还原
function recoverySelectedFiles(iftnos) {
  var arr = new Array();
  var cwh = getClientWH();
  if (iftnos) {
    arr.push(iftnos);
  } else {
    jQuery("input:checkbox[name='isolationfiles']:checked").each(function(i) {
      var filepath = jQuery(this).val();
      arr.push(filepath);
    });
  }

  if (arr.length) {
    var CreateDeleteSelectedFilesW = new MUI.Modal({
      id: 'CreateDeleteSelectedFilesWindow',
      title: UNAS._('Restore File'),
      modal: true,
      width: parseInt(cwh.w * 0.88),
      height: 200, //+50
      addClass:'delete-modal',
      data: {
        tip: '##$@clamav@$##Are you sure to restore the selected file?##$@clamav@$##'
      },
      modalOverlayClose: false,
      contentURL: '/apps/antivirus/m/clamav_isolation_delete.html?v=6.0.11'
    });
    CreateDeleteSelectedFilesW.ProcessCreateDeleteSelectedFilesWindow = function() {
      jQuery('#clamav_index_page_waiting_content').show();
      jQuery('#clamav_index_page_waiting_logo').show();

      jQuery.ajax({
        url: '/wmi/index.php',
        data: JSON.encode({
          "token": UToken,
          "cmd": 'antivirus_quarantined_restore',
          params: {
            iftnos: arr
          }
        }),
        dataType: "json",
        contentType: 'application/json',
        type: "post",
        async: true,
        timeout: 30000,
        success: function(result) {
          if (result.err == 0) {
            jQuery('#clamav_isolationfile_list').empty();
            quarantined_page = 1;
            clamavIsolationFileList(quarantined_page, quarantined_ofpage);
          } else {
            alert('Operation failed!');
          }
        },
        complete: function(xml) {
          jQuery('#clamav_index_page_waiting_content').hide();
          jQuery('#clamav_index_page_waiting_logo').hide();
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          alert(textStatus);

        }
      })
    }
  }
}

//多文件删除窗口
function DeleteSelectedFilesWin() {
  var files = [];
  jQuery("input:checkbox[name='isolationfiles']:checked").each(function(i) {
    files.push(jQuery(this).val());
  });
  var cwh = getClientWH();
  if (files.length) {
    var CreateDeleteSelectedFilesW = new MUI.Modal({
      id: 'CreateDeleteSelectedFilesWindow',
      title: UNAS._('Delete Isolation Files'),
      modal: true,
      width: parseInt(cwh.w * 0.88),
      height: 200, //+50
      addClass:'delete-modal',
      data: {
        tip: '##$@clamav@$##Are you sure you want to delete these files?##$@clamav@$##'
      },
      modalOverlayClose: false,
      contentURL: '/apps/antivirus/m/clamav_isolation_delete.html?v=6.0.11'
    });
    CreateDeleteSelectedFilesW.ProcessCreateDeleteSelectedFilesWindow = function() {
      deleteIsolationFile(files);
    }
  }
}

function removesolation(filepath) {
  var files = [];
  files.push(filepath);
  var cwh = getClientWH();
  var CreateDeleteSelectedFilesW = new MUI.Modal({
    id: 'CreateDeleteSelectedFilesWindow',
    title: UNAS._('Delete Isolation Files'),
    modal: true,
    width: parseInt(cwh.w * 0.88),
    height: 200, //+50
    addClass:'delete-modal',
    modalOverlayClose: false,
    data: {
      tip: '##$@clamav@$##Are you sure you want to delete file?##$@clamav@$##'
    },
    modalOverlayClose: false,
    contentURL: '/apps/antivirus/m/clamav_isolation_delete.html?v=6.0.11'
  });
  CreateDeleteSelectedFilesW.ProcessCreateDeleteSelectedFilesWindow = function() {
    deleteIsolationFile(files);
  }
}
//单文件删除
function deleteIsolationFile(files) {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'antivirus_quarantined_remove',
      params: {
        iftnos: files
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(result) {
      if (result.err == 0) {
        jQuery('#clamav_isolationfile_list').empty();
        quarantined_page = 1;
        clamavIsolationFileList(quarantined_page, quarantined_ofpage);
      } else {
        alert('Operation failed!');
      }

    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function quarantinedReduce() {
  jQuery('#clamav_index_page_waiting_content').show();
  jQuery('#clamav_index_page_waiting_logo').show();

  jQuery.ajax({
    url: '/wmi/index.php',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'antivirus_quarantined_reduce'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(result) {
      if (result.err == 0) {
        jQuery('#clamav_isolationfile_list').empty();
        quarantined_page = 1;
        clamavIsolationFileList(quarantined_page, quarantined_ofpage);
      } else {
        alert('Operation failed!');
      }

    },
    complete: function(xml) {
      jQuery('#clamav_index_page_waiting_content').hide();
      jQuery('#clamav_index_page_waiting_logo').hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

(function() {
  // jQuery("#jv-clamav-table").mCustomScrollbar({
  //   autoHideScrollbar: true,
  //   theme: "minimal-dark",
  //   callbacks: {
  //     onScrollStart: function() {},
  //     onScroll: function() {},
  //     onTotalScroll: function() {
  //
  //       if (quarantined_page == quarantined_pagecount) {
  //
  //       } else {
  //         quarantined_page++;
  //         clamavIsolationFileList(quarantined_page, quarantined_ofpage);
  //       }
  //
  //     }
  //   }
  // });
  // jQuery("#jv-clamav-table").
  jQuery('#jv-clamav-table').scroll(function() {
    // 获取div的总高度
    var totalHeight = jQuery(this)[0].scrollHeight;
    // 获取可视区域的高度
    var viewportHeight = jQuery(this).height();
    // 获取当前滚动条的位置
    var scrollTop = jQuery(this).scrollTop();
    // 检查是否已经到达底部
    var isBottom = totalHeight - (scrollTop + viewportHeight) <= 0;

    if (isBottom) {
      quarantined_page++;
      clamavIsolationFileList(quarantined_page, quarantined_ofpage);
    }
  });

  clamavIsolationFileList(quarantined_page, quarantined_ofpage);

  if (daemonstate) {
    jQuery('.clamav_isolation_btn').removeClass('disabledbtn');
    jQuery('#jv-clamav-table').removeClass('disabledbtn');
  } else {
    jQuery('.clamav_isolation_btn').addClass('disabledbtn');
    jQuery('#jv-clamav-table').addClass('disabledbtn');
  }

  jQuery('#jv-isolationallchk').on('click', function() {
    var allisolationfile = jQuery('#clamav_isolationfile_list input[name="isolationfiles"]');
    if (this.checked) {
      allisolationfile.prop('checked', true);
    } else {
      allisolationfile.prop('checked', false);
    }
  })
})()
